"<template>
  <div>
    <q-form 
      ref="tawag"
      @submit="!selected ? submitForm() : updateForm()"
      >

      <q-input 
        v-model="username"
        dense
        outlined 
        label="Username"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"
      />

      <q-input 
        v-model="email" 
        outlined 
        label="Email" 
        dense
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']" 
      />

      <q-input 
        v-model="password" 
        outlined
        dense
        label="Password" 
        type="password"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']" 
      />
      
      <div> 
      <q-btn
        :label="!selected ? 'Submit' : 'Update'"
        dense 
        type="submit"
        color="purple"
        style="margin-right: 10px"
        
      />
      
      <q-btn
        v-if = "selected"
        label="Delete"
        dense
        type="delete"
        color="red"
        @click="deleteForm()"
      />
      </div>

      
    </q-form>
    <div v-if="submitted">
      <div class="q-pa-md">
        <q-table
          class="my-sticky-header-column-table"
          title="My Accounts"
          :rows="rows"
          :columns="columns"
          row-key="name"
          @row-click="onRowClick"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { ref, computed } from 'vue';

export default {
  setup() {
    const username = ref('');
    const email = ref('');
    const password = ref('');
    const submitted = ref(false);
    const form = computed(() => ({
      username: username.value,
      email: email.value,
      password: password.value,
    }));
    const rows = ref([]);
    const columns = ref([
      { name: 'Username', field: 'username' },
      { name: 'Email', field: 'email' },
      { name: 'Password', field: 'password' }
    ]);

    let tawag = ref(null)

    function submitForm() {
      submitted.value = true;
      rows.value.push({ username: username.value, email: email.value, password: password.value });
      username.value = '';
      email.value = '';
      password.value = '';
      tawag.value.reset();
    }



    let selected = ref(null)
    function onRowClick (evt, row) {
      selected.value = row;
      username.value = row.username;
      email.value = row.email;
      password.value = row.password;
    }

    function updateForm() {
    const index = rows.value.findIndex(row => row === selected.value);
    rows.value.splice(index, 1, { username: username.value, email: email.value, password: password.value });
    selected.value = null;
    username.value = '';
    email.value = '';
    password.value = '';
    tawag.value.reset();
}

    function deleteForm() {
    const index = rows.value.findIndex(row => row === selected.value);
    rows.value.splice(index, 1);
    selected.value = null;
    username.value = '';
    email.value = '';
    password.value = '';
    tawag.value.reset();
}

    return {
      username,
      email,
      password,
      form,
      submitted,
      rows,
      columns,
      submitForm,
      tawag,
      onRowClick,
      updateForm,
      deleteForm,
      selected
    }
  }
};
</script>"